Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jgrapht.graph
Class AbstractBaseGraph<V,E>

    java.lang.Object
      org.jgrapht.graph.AbstractGraph<V,E>
          org.jgrapht.graph.AbstractBaseGraph<V,E>

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, Graph<V,E>

Direct Known Subclasses:
  DefaultDirectedGraph, DirectedMultigraph, DirectedPseudograph, Multigraph, Pseudograph, SimpleDirectedGraph, SimpleGraph

    public abstract class AbstractBaseGraph<V,E>

extends AbstractGraph<V,E>
implements Graph<V,E>, java.lang.Cloneable, java.io.Serializable

The most general implementation of the `Graph` interface. Its subclasses add various restrictions to get more specific graphs. The decision whether it is directed or undirected is decided at construction time and cannot be later modified (see constructor for details).

This graph implementation guarantees deterministic vertex and edge set ordering (via `LinkedHashMap` and `LinkedHashSet`).

Since:
  Jul 24, 2003
Author:
  Barak Naveh
See Also:
  Serialized Form

Constructor Summary
`AbstractBaseGraph(EdgeFactory<V,E> ef, boolean allowMultipleEdges, boolean allowLoops)` Construct a new pseudograph.

Method Summary
`E` | `addEdge(V sourceVertex, V targetVertex)` Creates a new edge in this graph, going from the source vertex to the target vertex, and returns the created edge.
`boolean` | `addEdge(V sourceVertex, V targetVertex, E e)` Adds the specified edge to this graph, going from the source vertex to the target vertex.
`boolean` | `addVertex(V v)` Adds the specified vertex to this graph if not already present.
`java.lang.Object` | `clone()` Returns a shallow copy of this graph instance.
`boolean` | `containsEdge(E e)` Returns `true` if this graph contains the specified edge.
`boolean` | `containsVertex(V v)` Returns `true` if this graph contains the specified vertex.
`int` | `degreeOf(V vertex)`
`java.util.Set<E>` | `edgeSet()` Returns a set of the edges contained in this graph.
`java.util.Set<E>` | `edgesOf(V vertex)` Returns a set of all edges touching the specified vertex.
`java.util.Set<E>` | `getAllEdges(V sourceVertex, V targetVertex)` Returns a set of all edges connecting source vertex to target vertex if such vertices exist in this graph.
`E` | `getEdge(V sourceVertex, V targetVertex)` Returns an edge connecting source vertex to target vertex if such vertices and such edge exist in this graph.
`EdgeFactory<V,E>` | `getEdgeFactory()` Returns the edge factory using which this graph creates new edges.
`V` | `getEdgeSource(E e)` Returns the source vertex of an edge.
`V` | `getEdgeTarget(E e)` Returns the target vertex of an edge.
`double` | `getEdgeWeight(E e)` Returns the weight assigned to a given edge.
`java.util.Set<E>` | `incomingEdgesOf(V vertex)`
`int` | `inDegreeOf(V vertex)`
`boolean` | `isAllowingLoops()` Returns `true` if and only if self-loops are allowed in this graph.
`boolean` | `isAllowingMultipleEdges()` Returns `true` if and only if multiple edges are allowed in this graph.
`int` | `outDegreeOf(V vertex)`
`java.util.Set<E>` | `outgoingEdgesOf(V vertex)`
`boolean` | `removeEdge(E e)` Removes the specified edge from the graph.
`E` | `removeEdge(V sourceVertex, V targetVertex)` Removes an edge going from source vertex to target vertex, if such vertices and such edge exist in this graph.
`boolean` | `removeVertex(V v)` Removes the specified vertex from this graph including all its touching edges if present.
`void` | `setEdgeSetFactory(EdgeSetFactory<V,E> edgeSetFactory)` Set the `EdgeSetFactory` to use for this graph.
`void` | `setEdgeWeight(E e, double weight)`
`java.util.Set<V>` | `vertexSet()` Returns a set of the vertices contained in this graph.

Methods inherited from class org.jgrapht.graph.AbstractGraph
`assertVertexExist, containsEdge, removeAllEdges, removeAllEdges, removeAllEdges, removeAllVertices, toString, toStringFromSets`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.jgrapht.Graph
`containsEdge, removeAllEdges, removeAllEdges, removeAllVertices`

Constructor Detail

### AbstractBaseGraph

    public AbstractBaseGraph(EdgeFactory<V,E> ef,
                             boolean allowMultipleEdges,
                             boolean allowLoops)

  Construct a new pseudograph. The pseudograph can either be directed or undirected, depending on the specified edge factory.

  Parameters:
    `ef` - the edge factory of the new graph.
    `allowMultipleEdges` - whether to allow multiple edges or not.
    `allowLoops` - whether to allow edges that are self-loops or not.
  Throws:
    `java.lang.NullPointerException` - if the specified edge factory is `null`.

Method Detail

### getAllEdges

    public java.util.Set<E> getAllEdges(V sourceVertex,
                                        V targetVertex)

  Description copied from interface: `Graph`
  Returns a set of all edges connecting source vertex to target vertex if such vertices exist in this graph. If any of the vertices does not exist or is `null`, returns `null`. If both vertices exist but no edges found, returns an empty set.

  In undirected graphs, some of the returned edges may have their source and target vertices in the opposite order. In simple graphs the returned set is either singleton set or empty set.

  Specified by:
    `getAllEdges` in interface `Graph<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
  Returns:
    a set of all edges connecting source vertex to target vertex.
  See Also:
    `Graph.getAllEdges(Object, Object)`

### isAllowingLoops

    public boolean isAllowingLoops()

  Returns `true` if and only if self-loops are allowed in this graph. A self loop is an edge that its source and target vertices are the same.

  Returns:
    `true` if and only if graph loops are allowed.

### isAllowingMultipleEdges

    public boolean isAllowingMultipleEdges()

  Returns `true` if and only if multiple edges are allowed in this graph. The meaning of multiple edges is that there can be many edges going from vertex v1 to vertex v2.

  Returns:
    `true` if and only if multiple edges are allowed.

### getEdge

    public E getEdge(V sourceVertex,
                     V targetVertex)

  Description copied from interface: `Graph`
  Returns an edge connecting source vertex to target vertex if such vertices and such edge exist in this graph. Otherwise returns `null`. If any of the specified vertices is `null` returns `null`

  In undirected graphs, the returned edge may have its source and target vertices in the opposite order.

  Specified by:
    `getEdge` in interface `Graph<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
  Returns:
    an edge connecting source vertex to target vertex.
  See Also:
    `Graph.getEdge(Object, Object)`

### getEdgeFactory

    public EdgeFactory<V,E> getEdgeFactory()

  Description copied from interface: `Graph`
  Returns the edge factory using which this graph creates new edges. The edge factory is defined when the graph is constructed and must not be modified.

  Specified by:
    `getEdgeFactory` in interface `Graph<V,E>`
  Returns:
    the edge factory using which this graph creates new edges.
  See Also:
    `Graph.getEdgeFactory()`

### setEdgeSetFactory

    public void setEdgeSetFactory(EdgeSetFactory<V,E> edgeSetFactory)

  Set the `EdgeSetFactory` to use for this graph. Initially, a graph is created with a default implementation which always supplies an `ArrayList` with capacity 1.

  Parameters:
    `edgeSetFactory` - factory to use for subsequently created edge sets (this call has no effect on existing edge sets)

### addEdge

    public E addEdge(V sourceVertex,
                     V targetVertex)

  Description copied from interface: `Graph`
  Creates a new edge in this graph, going from the source vertex to the target vertex, and returns the created edge. Some graphs do not allow edge-multiplicity. In such cases, if the graph already contains an edge from the specified source to the specified target, than this method does not change the graph and returns `null`.

  The source and target vertices must already be contained in this graph. If they are not found in graph IllegalArgumentException is thrown.

  This method creates the new edge `e` using this graph's `EdgeFactory`. For the new edge to be added `e` must not be equal to any other edge the graph (even if the graph allows edge-multiplicity). More formally, the graph must not contain any edge `e2` such that `e2.equals(e)`. If such `e2` is found then the newly created edge `e` is abandoned, the method leaves this graph unchanged returns `null`.

  Specified by:
    `addEdge` in interface `Graph<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
  Returns:
    The newly created edge if added to the graph, otherwise `null`.
  See Also:
    `Graph.addEdge(Object, Object)`

### addEdge

    public boolean addEdge(V sourceVertex,
                           V targetVertex,
                           E e)

  Description copied from interface: `Graph`
  Adds the specified edge to this graph, going from the source vertex to the target vertex. More formally, adds the specified edge, `e`, to this graph if this graph contains no edge `e2` such that `e2.equals(e)`. If this graph already contains such an edge, the call leaves this graph unchanged and returns `false`. Some graphs do not allow edge-multiplicity. In such cases, if the graph already contains an edge from the specified source to the specified target, than this method does not change the graph and returns `false`. If the edge was added to the graph, returns `true`.

  The source and target vertices must already be contained in this graph. If they are not found in graph IllegalArgumentException is thrown.

  Specified by:
    `addEdge` in interface `Graph<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
    `e` - edge to be added to this graph.
  Returns:
    `true` if this graph did not already contain the specified edge.
  See Also:
    `Graph.addEdge(Object, Object, Object)`

### addVertex

    public boolean addVertex(V v)

  Description copied from interface: `Graph`
  Adds the specified vertex to this graph if not already present. More formally, adds the specified vertex, `v`, to this graph if this graph contains no vertex `u` such that `u.equals(v)`. If this graph already contains such vertex, the call leaves this graph unchanged and returns `false`. In combination with the restriction on constructors, this ensures that graphs never contain duplicate vertices.

  Specified by:
    `addVertex` in interface `Graph<V,E>`
  Parameters:
    `v` - vertex to be added to this graph.
  Returns:
    `true` if this graph did not already contain the specified vertex.
  See Also:
    `Graph.addVertex(Object)`

### getEdgeSource

    public V getEdgeSource(E e)

  Description copied from interface: `Graph`
  Returns the source vertex of an edge. For an undirected graph, source and target are distinguishable designations (but without any mathematical meaning).

  Specified by:
    `getEdgeSource` in interface `Graph<V,E>`
  Parameters:
    `e` - edge of interest
  Returns:
    source vertex
  See Also:
    `Graph.getEdgeSource(Object)`

### getEdgeTarget

    public V getEdgeTarget(E e)

  Description copied from interface: `Graph`
  Returns the target vertex of an edge. For an undirected graph, source and target are distinguishable designations (but without any mathematical meaning).

  Specified by:
    `getEdgeTarget` in interface `Graph<V,E>`
  Parameters:
    `e` - edge of interest
  Returns:
    target vertex
  See Also:
    `Graph.getEdgeTarget(Object)`

### clone

    public java.lang.Object clone()

  Returns a shallow copy of this graph instance. Neither edges nor vertices are cloned.

  Overrides:
    `clone` in class `java.lang.Object`
  Returns:
    a shallow copy of this set.
  Throws:
    `java.lang.RuntimeException`
  See Also:
    `Object.clone()`

### containsEdge

    public boolean containsEdge(E e)

  Description copied from interface: `Graph`
  Returns `true` if this graph contains the specified edge. More formally, returns `true` if and only if this graph contains an edge `e2` such that `e.equals(e2)`. If the specified edge is `null` returns `false`.

  Specified by:
    `containsEdge` in interface `Graph<V,E>`
  Parameters:
    `e` - edge whose presence in this graph is to be tested.
  Returns:
    `true` if this graph contains the specified edge.
  See Also:
    `Graph.containsEdge(Object)`

### containsVertex

    public boolean containsVertex(V v)

  Description copied from interface: `Graph`
  Returns `true` if this graph contains the specified vertex. More formally, returns `true` if and only if this graph contains a vertex `u` such that `u.equals(v)`. If the specified vertex is `null` returns `false`.

  Specified by:
    `containsVertex` in interface `Graph<V,E>`
  Parameters:
    `v` - vertex whose presence in this graph is to be tested.
  Returns:
    `true` if this graph contains the specified vertex.
  See Also:
    `Graph.containsVertex(Object)`

### degreeOf

    public int degreeOf(V vertex)

  See Also:
    `UndirectedGraph.degreeOf(Object)`

### edgeSet

    public java.util.Set<E> edgeSet()

  Description copied from interface: `Graph`
  Returns a set of the edges contained in this graph. The set is backed by the graph, so changes to the graph are reflected in the set. If the graph is modified while an iteration over the set is in progress, the results of the iteration are undefined.

  The graph implementation may maintain a particular set ordering (e.g. via `LinkedHashSet`) for deterministic iteration, but this is not required. It is the responsibility of callers who rely on this behavior to only use graph implementations which support it.

  Specified by:
    `edgeSet` in interface `Graph<V,E>`
  Returns:
    a set of the edges contained in this graph.
  See Also:
    `Graph.edgeSet()`

### edgesOf

    public java.util.Set<E> edgesOf(V vertex)

  Description copied from interface: `Graph`
  Returns a set of all edges touching the specified vertex. If no edges are touching the specified vertex returns an empty set.

  Specified by:
    `edgesOf` in interface `Graph<V,E>`
  Parameters:
    `vertex` - the vertex for which a set of touching edges is to be returned.
  Returns:
    a set of all edges touching the specified vertex.
  See Also:
    `Graph.edgesOf(Object)`

### inDegreeOf

    public int inDegreeOf(V vertex)

  See Also:
    `DirectedGraph.inDegreeOf(Object)`

### incomingEdgesOf

    public java.util.Set<E> incomingEdgesOf(V vertex)

  See Also:
    `DirectedGraph.incomingEdgesOf(Object)`

### outDegreeOf

    public int outDegreeOf(V vertex)

  See Also:
    `DirectedGraph.outDegreeOf(Object)`

### outgoingEdgesOf

    public java.util.Set<E> outgoingEdgesOf(V vertex)

  See Also:
    `DirectedGraph.outgoingEdgesOf(Object)`

### removeEdge

    public E removeEdge(V sourceVertex,
                        V targetVertex)

  Description copied from interface: `Graph`
  Removes an edge going from source vertex to target vertex, if such vertices and such edge exist in this graph. Returns the edge if removed or `null` otherwise.

  Specified by:
    `removeEdge` in interface `Graph<V,E>`
  Parameters:
    `sourceVertex` - source vertex of the edge.
    `targetVertex` - target vertex of the edge.
  Returns:
    The removed edge, or `null` if no edge removed.
  See Also:
    `Graph.removeEdge(Object, Object)`

### removeEdge

    public boolean removeEdge(E e)

  Description copied from interface: `Graph`
  Removes the specified edge from the graph. Removes the specified edge from this graph if it is present. More formally, removes an edge `e2` such that `e2.equals(e)`, if the graph contains such edge. Returns `true` if the graph contained the specified edge. (The graph will not contain the specified edge once the call returns).

  If the specified edge is `null` returns `false`.

  Specified by:
    `removeEdge` in interface `Graph<V,E>`
  Parameters:
    `e` - edge to be removed from this graph, if present.
  Returns:
    `true` if and only if the graph contained the specified edge.
  See Also:
    `Graph.removeEdge(Object)`

### removeVertex

    public boolean removeVertex(V v)

  Description copied from interface: `Graph`
  Removes the specified vertex from this graph including all its touching edges if present. More formally, if the graph contains a vertex `u` such that `u.equals(v)`, the call removes all edges that touch `u` and then removes `u` itself. If no such `u` is found, the call leaves the graph unchanged. Returns `true` if the graph contained the specified vertex. (The graph will not contain the specified vertex once the call returns).

  If the specified vertex is `null` returns `false`.

  Specified by:
    `removeVertex` in interface `Graph<V,E>`
  Parameters:
    `v` - vertex to be removed from this graph, if present.
  Returns:
    `true` if the graph contained the specified vertex; `false` otherwise.
  See Also:
    `Graph.removeVertex(Object)`

### vertexSet

    public java.util.Set<V> vertexSet()

  Description copied from interface: `Graph`
  Returns a set of the vertices contained in this graph. The set is backed by the graph, so changes to the graph are reflected in the set. If the graph is modified while an iteration over the set is in progress, the results of the iteration are undefined.

  The graph implementation may maintain a particular set ordering (e.g. via `LinkedHashSet`) for deterministic iteration, but this is not required. It is the responsibility of callers who rely on this behavior to only use graph implementations which support it.

  Specified by:
    `vertexSet` in interface `Graph<V,E>`
  Returns:
    a set view of the vertices contained in this graph.
  See Also:
    `Graph.vertexSet()`

### getEdgeWeight

    public double getEdgeWeight(E e)

  Description copied from interface: `Graph`
  Returns the weight assigned to a given edge. Unweighted graphs return 1.0 (as defined by `WeightedGraph.DEFAULT_EDGE_WEIGHT`), allowing weighted-graph algorithms to apply to them where meaningful.

  Specified by:
    `getEdgeWeight` in interface `Graph<V,E>`
  Parameters:
    `e` - edge of interest
  Returns:
    edge weight
  See Also:
    `Graph.getEdgeWeight(Object)`

### setEdgeWeight

    public void setEdgeWeight(E e,
                              double weight)

  See Also:
    `WeightedGraph.setEdgeWeight(Object, double)`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD